diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRawApplicationPackets2.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 2,67 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  import ncsa.hdf.hdf5lib.exceptions.HDF5LibraryException;
  
! public class SpacecraftDiaryRawApplicationPackets2 extends RawApplicationPackets {
  
  	private long firstTime = -1l;
  	private boolean fullGranule = false;
  	private Stats stats = null;
  	private long currentTimeOfGranule = 0l;
  
! 	public SpacecraftDiaryRawApplicationPackets2(SpacecraftId satellite, int setNum, PacketPool packetPool) {
! 		super(satellite,  RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  	}
! 	
! 	public SpacecraftDiaryRawApplicationPackets2(Stats stats, SpacecraftId satellite, int setNum, PacketPool packetPool) {
! 		super(satellite,  RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  		this.stats = stats;
  	}
! 	
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that pre-exists.
! 	 * The contents of the dataspace are read into a memory buffer... assuming it will fit.
! 	 * @param allRDRId  the rdrAll Groups id
! 	 * @param setNum the set number of raw entry
! 	 * @throws NullPointerException 
! 	 * @throws HDF5LibraryException 
! 	 * @throws RtStpsException 
  	 */
! 	public SpacecraftDiaryRawApplicationPackets2(int allRDRId, int setNum) throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 	
! 	public SpacecraftDiaryRawApplicationPackets2(int readId, int setNum, boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
  
  
! 	@Override
  	public boolean notFull(Packet p) throws RtStpsException {
  		boolean notFull = true;
! 		//System.out.println("S/C APID:"+p.getApplicationId()+":"+p.getTimeStamp(8));
! 		if (p.getApplicationId() == 11) {  // idea is we allow apid=0 and 8 in but only check for fullness on apid=11
  			long timestamp = p.getTimeStamp(8);
! 			if (this.firstTime < 0l) {
! 				this.firstTime = timestamp;
! 			} else {
! 				
! 				if (greaterThanEqualTo(timestamp, firstTime, 20)) {
! 					notFull = false;  // if 20secs have gone by, the granule is full
! 					fullGranule = true;
  				}
  			}
  		}
--- 2,184 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  import ncsa.hdf.hdf5lib.exceptions.HDF5LibraryException;
  
! public class SpacecraftDiaryRawApplicationPackets2 extends
! 		RawApplicationPackets {
  
  	private long firstTime = -1l;
  	private boolean fullGranule = false;
  	private Stats stats = null;
  	private long currentTimeOfGranule = 0l;
  
! 	public SpacecraftDiaryRawApplicationPackets2(SpacecraftId satellite,
! 			int setNum, PacketPool packetPool) {
! 		super(satellite, RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  	}
! 
! 	public SpacecraftDiaryRawApplicationPackets2(Stats stats,
! 			SpacecraftId satellite, int setNum, PacketPool packetPool) {
! 		super(satellite, RDRName.NPP_Ephemeris_and_Attitude, setNum, packetPool);
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  		this.stats = stats;
  	}
! 
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that
! 	 * pre-exists. The contents of the dataspace are read into a memory
! 	 * buffer... assuming it will fit.
! 	 * 
! 	 * @param allRDRId
! 	 *            the rdrAll Groups id
! 	 * @param setNum
! 	 *            the set number of raw entry
! 	 * @throws NullPointerException
! 	 * @throws HDF5LibraryException
! 	 * @throws RtStpsException
  	 */
! 	public SpacecraftDiaryRawApplicationPackets2(int allRDRId, int setNum)
! 			throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 
! 	public SpacecraftDiaryRawApplicationPackets2(int readId, int setNum,
! 			boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
  
+ 	// @Override
+ 	// public boolean notFull(Packet p) throws RtStpsException {
+ 	// boolean notFull = true;
+ 	// //System.out.println("S/C APID:"+p.getApplicationId()+":"+p.getTimeStamp(8));
+ 	// if (p.getApplicationId() == 11) { // idea is we allow apid=0 and 8 in but
+ 	// only check for fullness on apid=11
+ 	// long timestamp = p.getTimeStamp(8);
+ 	// if (this.firstTime < 0l) {
+ 	// this.firstTime = timestamp;
+ 	// } else {
+ 	//
+ 	// if (greaterThanEqualTo(timestamp, firstTime, 20)) {
+ 	// notFull = false; // if 20secs have gone by, the granule is full
+ 	// fullGranule = true;
+ 	// }
+ 	// }
+ 	// }
+ 	// return notFull;
+ 	// }
  
! 	// static long firstTime = -1;
! 
! 	/**
! 	 * Granules are created from scans. Scans in VIIRS are lots of packets the
! 	 * first 800 w/with a secondaryheader is used here to signal the start of a
! 	 * scan. We collect it and everything after it as one scan until it
! 	 * re-appears. Anything more complex than this can be built on top of this
! 	 * one assumption.
! 	 * 
! 	 * @param p
! 	 *            a Packet to be put into the VIIRS RawApplicationPackets area
! 	 * @return true if it can be put there, or false if it is full and should be
! 	 *         written to disk first
! 	 * @exception wraps
! 	 *                any HDF exceptions in RtStpsException
! 	 */
  	public boolean notFull(Packet p) throws RtStpsException {
+ 
  		boolean notFull = true;
! 		// System.out.println("S/C APID:"+p.getApplicationId()+":"+p.getTimeStamp(8));
! //		if (p.getApplicationId() == 11) 
! 		{ // idea is we allow apid=0 and 8 in
! 											// but only check for fullness on
! 											// apid=11
! 
  			long timestamp = p.getTimeStamp(8);
! 
! 			GranuleId currentGranId = new GranuleId(SpacecraftId.npp,
! 					p.getTimeStamp(8),
! 					RDRName.NPP_Ephemeris_and_Attitude);
! 
! 			LeapDate obsTime = new LeapDate(timestamp);
! 			// System.out.printf("VIIRS: Gran %s seq %d ts %d obs %d \n",
! 			// currentGranId.toString(), p.getSequenceCounter(),
! 			// timestamp, obsTime.getMicrosSinceEpoch());
! 
! 			if (currentGranId.toString().startsWith("NPP-") == false) {
! 
! 				if (this.firstTime < 0l) {
! 					this.firstTime = timestamp;
! 					setFirstTime(timestamp);
! 				} else {
! 					GranuleId startGranId = new GranuleId(SpacecraftId.npp,
! 							getFirstTime(), 
! 							RDRName.NPP_Ephemeris_and_Attitude);
! 					
! 					
! 					LeapDate startObs = new LeapDate(getFirstTime());  //srm
! 				//	long pktObservationTime = new LeapDate(timestamp).getMicrosSinceEpoch();
! 					
! 					
! 				//	long granuleEndTime =	GranuleId.calcGranuleEndTime(startObs.getMicrosSinceEpoch(), RDRName.NPP_Ephemeris_and_Attitude);
! 
! //					if ( granuleEndTime < pktObservationTime )
! //					{
! //						System.out.printf("DIARY: %s Cur %s e %d ec %d\n" , startGranId.toString()
! //								, currentGranId.toString(),granuleEndTime,pktObservationTime );
! //
! //					}
! 					
! 					
! //					if (startGranId.toString().contentEquals(
! //							currentGranId.toString()) == false) {
! //						firstTime = -1;
! //						System.out.println("DIARY: " + startGranId.toString()
! //								+ " Current:" + currentGranId.toString());
! //
! //						notFull = false; // if 20secs have gone by, the granule
! //											// is full
! //						fullGranule = true;
! //
! //					}
! 					
! 					LPEATEDate lpd = new LPEATEDate(getFirstTime());
! 					long ietTimeThis = lpd.getMicrosSinceEpoch();
! 					long stThis = GranuleId.calcGranuleStartTime(ietTimeThis,
! 							RDRName.NPP_Ephemeris_and_Attitude);
! 
! 					lpd = new LPEATEDate(p.getTimeStamp(8));
! 					long ietTimeNext = lpd.getMicrosSinceEpoch();
! 					long stNext = GranuleId.calcGranuleStartTime(ietTimeNext,
! 							RDRName.NPP_Ephemeris_and_Attitude);
! 
! //					System.out.printf(
! //							"DIARY ietthis: %d start: %d Next %d %d\n",
! //							ietTimeThis, stThis, ietTimeNext, stNext);
! 
! 					
! 					if( stThis != stNext )
! 					{
! //						System.out.println("DIARY: " + startGranId.toString()
! //								+ " Current:" + currentGranId.toString());
! 
! 						notFull = false; // if 20secs have gone by, the granule
! 											// is full
! 						fullGranule = true;
! 
! 					}
! 					
! 					
! 					
! 					
  				}
  			}
  		}
***************
*** 71,167 ****
  	@Override
  	public void put(Packet p) throws RtStpsException {
  		this.updateAppIdCounters(p.getApplicationId());
- 		
- 		if (p.getApplicationId() == 11) {// idea is we allow apid=0 and 8 in but only check for fullness on apid=11
  
! 			// secondary time stamp only valid in in first or standalone packets...
  			if (getFirstTime() == 0L) {
! 				//System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 			
  			setLastTime(p.getTimeStamp(8));
  		}
! 		
  		// the packet is deep copied, it is allocated off a pool
! 		// which may hold previously copied packets...  they must be put
  		// back on the pool when done...
! 		
  		Packet pcopy = CopyPacket.deep(p, packetPool);
! 		
  		getPacketList().add(pcopy);
  	}
! 	
  	/**
! 	 * Write the collected group of packets to the designated HDF file using the handle
  	 * @return true if the RawApplicationPacket was written, false if not
! 	 * @exception any HDF exceptions are wrapped in an RtStpsException
  	 */
  	public boolean write(int hdfFile) throws RtStpsException {
  		boolean ret = true;
  		if (fullGranule == true) {
! 			
! 			
  			if (stats == null) {
! 				System.out.println("Creating Spacecraft Diary Granule -- [" + 20 + "] seconds"); // FIXME do we show them the real time or the near time?
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 			
  			ret = super.write(hdfFile);
! 			
! 			
  		} else {
! 			
  			if (stats == null) {
! 				double time = currentTimeOfGranule/1000000.0;
! 				System.out.println("Creating Partial Spacecraft Diary Granule -- [" + time + "] seconds");
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 			
  			ret = super.write(hdfFile);
  		}
! 		
  		fullGranule = false;
  		this.firstTime = -1l;
! 		
  		return ret;
  	}
! 	
  	/**
! 	 * Close out the RawApplicationPacket which writes the results to the HDF file and cleans up.
! 	 * @exception any HDF exceptions are wrapped in an RtStpsException
  	 */
  	public void close() throws RtStpsException {
  		super.close();
! 		this.firstTime = -1L; 
  		fullGranule = false;
  	}
! 	
  	// see if time between current time and old time is X seconds or more
! 	public boolean greaterThanEqualTo(long timeStamp1, long timeStamp2, int seconds) {
! 		
  		long rawDay1 = (timeStamp1 >> 48) & 0x0ffffL;
  		long rawMillis1 = (timeStamp1 >> 16) & 0x0ffffffffL;
  		long rawMicros1 = timeStamp1 & 0x0ffffL;
! 		
  		long micros1 = 86400000000l * rawDay1;
  		micros1 += rawMillis1 * 1000l;
  		micros1 += rawMicros1;
! 		
  		long rawDay2 = (timeStamp2 >> 48) & 0x0ffffL;
  		long rawMillis2 = (timeStamp2 >> 16) & 0x0ffffffffL;
  		long rawMicros2 = timeStamp2 & 0x0ffffL;
! 		
  		long micros2 = 86400000000l * rawDay2;
  		micros2 += rawMillis2 * 1000l;
  		micros2 += rawMicros2;
! 		
  		currentTimeOfGranule = micros1 - micros2;
! 		
! 		long tmp2 = (long)seconds * 1000000l;
  		return (currentTimeOfGranule >= tmp2);
  	}
! 	
  }
--- 188,296 ----
  	@Override
  	public void put(Packet p) throws RtStpsException {
  		this.updateAppIdCounters(p.getApplicationId());
  
! 		if (p.getApplicationId() == 11) {// idea is we allow apid=0 and 8 in but
! 											// only check for fullness on
! 											// apid=11
! 
! 			// secondary time stamp only valid in in first or standalone
! 			// packets...
  			if (getFirstTime() == 0L) {
! 				// System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 
  			setLastTime(p.getTimeStamp(8));
  		}
! 
  		// the packet is deep copied, it is allocated off a pool
! 		// which may hold previously copied packets... they must be put
  		// back on the pool when done...
! 
  		Packet pcopy = CopyPacket.deep(p, packetPool);
! 
  		getPacketList().add(pcopy);
  	}
! 
  	/**
! 	 * Write the collected group of packets to the designated HDF file using the
! 	 * handle
! 	 * 
  	 * @return true if the RawApplicationPacket was written, false if not
! 	 * @exception any
! 	 *                HDF exceptions are wrapped in an RtStpsException
  	 */
  	public boolean write(int hdfFile) throws RtStpsException {
  		boolean ret = true;
  		if (fullGranule == true) {
! 
  			if (stats == null) {
! 				System.out.println("Creating Spacecraft Diary Granule -- ["
! 						+ 20 + "] seconds"); // FIXME do we show them the real
! 												// time or the near time?
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 
  			ret = super.write(hdfFile);
! 
  		} else {
! 
  			if (stats == null) {
! 				double time = currentTimeOfGranule / 1000000.0;
! 				System.out
! 						.println("Creating Partial Spacecraft Diary Granule -- ["
! 								+ time + "] seconds");
  			} else {
  				stats.ae_createdGranules.value++;
  			}
! 
  			ret = super.write(hdfFile);
  		}
! 
  		fullGranule = false;
  		this.firstTime = -1l;
! 
  		return ret;
  	}
! 
  	/**
! 	 * Close out the RawApplicationPacket which writes the results to the HDF
! 	 * file and cleans up.
! 	 * 
! 	 * @exception any
! 	 *                HDF exceptions are wrapped in an RtStpsException
  	 */
  	public void close() throws RtStpsException {
  		super.close();
! 		this.firstTime = -1L;
  		fullGranule = false;
  	}
! 
  	// see if time between current time and old time is X seconds or more
! 	public boolean greaterThanEqualTo(long timeStamp1, long timeStamp2,
! 			int seconds) {
! 
  		long rawDay1 = (timeStamp1 >> 48) & 0x0ffffL;
  		long rawMillis1 = (timeStamp1 >> 16) & 0x0ffffffffL;
  		long rawMicros1 = timeStamp1 & 0x0ffffL;
! 
  		long micros1 = 86400000000l * rawDay1;
  		micros1 += rawMillis1 * 1000l;
  		micros1 += rawMicros1;
! 
  		long rawDay2 = (timeStamp2 >> 48) & 0x0ffffL;
  		long rawMillis2 = (timeStamp2 >> 16) & 0x0ffffffffL;
  		long rawMicros2 = timeStamp2 & 0x0ffffL;
! 
  		long micros2 = 86400000000l * rawDay2;
  		micros2 += rawMillis2 * 1000l;
  		micros2 += rawMicros2;
! 
  		currentTimeOfGranule = micros1 - micros2;
! 
! 		long tmp2 = (long) seconds * 1000000l;
  		return (currentTimeOfGranule >= tmp2);
  	}
! 
  }
diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRDR.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRDR.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRDR.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/SpacecraftDiaryRDR.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 249,255 ****
  
  		Granule granule = Granule.factory(rap,
  										1L,
! 										new GranuleId(SpacecraftId.npp, rap.getFirstTime(), 0 /** HACK **/, rap.getTimeSpan()),
  										LEOAFlag.Off,
  										RDR.DocumentName,
  										rap.getPacketTypes(),
--- 249,255 ----
  
  		Granule granule = Granule.factory(rap,
  										1L,
! 										new GranuleId(SpacecraftId.npp, rap.getFirstTime(),rdrName),
  										LEOAFlag.Off,
  										RDR.DocumentName,
  										rap.getPacketTypes(),
diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/StaticHeader.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/StaticHeader.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/StaticHeader.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/StaticHeader.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 2,8 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
--- 2,8 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
